=begin
#Backscatter.io

#[This is the Backscatter.io API.](https://backscatter.io/developers) 

OpenAPI spec version: 1.0.0
Contact: info@backscatter.io
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.0

=end

require 'date'

module BackscatterIO
  class Summary
    attr_accessor :autonomous_system_count

    attr_accessor :has_observations

    attr_accessor :ip_address_count

    attr_accessor :network_count

    attr_accessor :observations

    attr_accessor :observations_count

    attr_accessor :port_count

    attr_accessor :protocol_count

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'autonomous_system_count' => :'autonomous_system_count',
        :'has_observations' => :'has_observations',
        :'ip_address_count' => :'ip_address_count',
        :'network_count' => :'network_count',
        :'observations' => :'observations',
        :'observations_count' => :'observations_count',
        :'port_count' => :'port_count',
        :'protocol_count' => :'protocol_count'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'autonomous_system_count' => :'Integer',
        :'has_observations' => :'BOOLEAN',
        :'ip_address_count' => :'Array<String>',
        :'network_count' => :'Integer',
        :'observations' => :'BOOLEAN',
        :'observations_count' => :'Integer',
        :'port_count' => :'Integer',
        :'protocol_count' => :'Integer'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'autonomous_system_count')
        self.autonomous_system_count = attributes[:'autonomous_system_count']
      end

      if attributes.has_key?(:'has_observations')
        self.has_observations = attributes[:'has_observations']
      end

      if attributes.has_key?(:'ip_address_count')
        if (value = attributes[:'ip_address_count']).is_a?(Array)
          self.ip_address_count = value
        end
      end

      if attributes.has_key?(:'network_count')
        self.network_count = attributes[:'network_count']
      end

      if attributes.has_key?(:'observations')
        self.observations = attributes[:'observations']
      end

      if attributes.has_key?(:'observations_count')
        self.observations_count = attributes[:'observations_count']
      end

      if attributes.has_key?(:'port_count')
        self.port_count = attributes[:'port_count']
      end

      if attributes.has_key?(:'protocol_count')
        self.protocol_count = attributes[:'protocol_count']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          autonomous_system_count == o.autonomous_system_count &&
          has_observations == o.has_observations &&
          ip_address_count == o.ip_address_count &&
          network_count == o.network_count &&
          observations == o.observations &&
          observations_count == o.observations_count &&
          port_count == o.port_count &&
          protocol_count == o.protocol_count
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [autonomous_system_count, has_observations, ip_address_count, network_count, observations, observations_count, port_count, protocol_count].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = BackscatterIO.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
